package ssc;

import java.awt.*;
import java.util.*;

/**
 * This class implements the logic of the Battle-field which
 * containes {@link Building}, {@link Unit} and {@link Landscape}
 * @author Gavrilov M.
 */

class BattleField {
    /**
     * Landscape
     */
    public Landscape landscape = new Landscape();

    /**
     *   
     */
    public Point viewCenter = new Point();

    /**
     *   GameObject,     
     */
    public Vector units = new Vector();

    /**
     *   Bullet    
     */
    public Vector bullets = new Vector();

    /**
     *   Burst    
     */
    public Vector bursts = new Vector();

    /**
     * .       
     *  
     */
    public BattleField() {
        units.add(new Building(this, "Building #1", 1, 50, 10));
        units.add(new Building(this, "Building #2", 1, 50, 110));
        units.add(new Building(this, "Building #3", 1, 50, 210));
        units.add(new Building(this, "Building #4", 2, 400, 10));
        units.add(new Building(this, "Building #5", 2, 400, 110));
        units.add(new Building(this, "Building #6", 2, 400, 210));

        units.add(new Unit(this, "Unit #1", 1, 100, 10));
        units.add(new Unit(this, "Unit #2", 1, 100, 110));
        units.add(new Unit(this, "Unit #3", 1, 100, 210));

        units.add(new Unit(this, "Unit #4", 2, 300, 10));
        units.add(new Unit(this, "Unit #5", 2, 300, 110));
        units.add(new Unit(this, "Unit #6", 2, 300, 210));
    }

    public void screenToAbsolute(Point x) {
        x.x -= viewCenter.x;
        x.y -= viewCenter.y;
    }

    public void processTimer() {
        int i;
        for (i = 0; i < units.size(); i++) {
            if (units.elementAt(i) instanceof Unit) {
                Unit unit = (Unit) units.elementAt(i);
                if ((unit != null) && (unit.isAlive())) {
                    unit.runAllScanners();
                    switch (unit.getA0().getState()) {
                        case 0:
                            break;

                        case 1:
                            unit.move();
                            break;

                        case 5:
                            unit.move();
                            break;

                        default:
                            break;
                    }
                    ;
                }
                ;
            }
        }
        ;

        for (i = 0; i < bullets.size(); i++) {
            Bullet bullet = (Bullet) bullets.elementAt(i);
            bullet.move();
        }
    }

    public void checkDeaded() {
        int i;
        for (i = 0; i < units.size(); i++) {
            GameObject go = (GameObject) units.elementAt(i);
            if ((go != null) && (!(go.isAlive()))) {
                units.remove(go);
            }
            ;
        }
        ;

        for (i = 0; i < bullets.size(); i++) {
            Bullet bullet = (Bullet) bullets.elementAt(i);
            if (!bullet.isAlive()) bullets.remove(bullet);
        }
        ;

        for (i = 0; i < bursts.size(); i++) {
            Burst burst = (Burst) bursts.elementAt(i);
            if (!burst.isAlive()) bursts.remove(burst);
        }
        ;

    }

    public void paint(Graphics g, int width, int height) {
        landscape.paint(g, viewCenter.x, viewCenter.y, width, height);
        g.translate(viewCenter.x, viewCenter.y);
        int i;
        for (i = 0; i < units.size(); i++) ((GameObject) units.elementAt(i)).paint(g);

        for (i = 0; i < bullets.size(); i++) ((Bullet) bullets.elementAt(i)).paint(g);

        for (i = 0; i < bursts.size(); i++) ((Burst) bursts.elementAt(i)).paint(g);
    }
}