package ssc;

/**
 * This class implements the logic of the unit's cannon
 */
public class Cannon {

    /**
     * This class implement the logic of automat "Cannon"
     */
    class AutomatCannon extends Automat {

        /**
         * Default constructor
         */
        public AutomatCannon() {
            setLogged(true);
            setStatesCount(3);
            setStateName(0, "Not shooting. Timer is swiched off");
            setStateName(1, "Shooting. Timer is swiched on");
            setStateName(2, "Not shooting. Timer is swiched on");
            setState(0);
            setType("A2");
            setName(getCannonName());
            logLaunch(getState());
        };


        // 
        public void z1() {
            timerTask = new CannonTimerTask();
            timer.schedule(timerTask, 10, 2000);
            logZ(1, "Switch on timer");
        };

        // 
        public void z2() {
            owner.getField().bullets.add(new Bullet(owner));
            logZ(2, "Launch a rocket");
        };

        // 
        public void z3() {
            timerTask.cancel();
            logZ(3, "Switch off timer");
        };

        public void A(int e) {
            int y0 = getState();
            int yold = y0;
            switch (y0) {
                case 0:
                    if (e == 1) {
                        z1();
                        y0 = 1;
                    }
                    break;

                case 1:
                    if (e == 2) {
                        y0 = 2;
                    }
                    if (e == 3) {
                        z2();
                        y0 = 1;
                    }
                    break;

                case 2:
                    if (e == 1) {
                        y0 = 1;
                    }
                    if (e == 3) {
                        z3();
                        y0 = 0;
                    }
                    break;

                default:
                    break;
            }

            if (y0 != yold) logTrans(y0, yold, e);
            setState(y0);
        }
    };

    private String cannonName;

    /**
     * Returns cannon's name
     */
    public String getCannonName() {
        return cannonName;
    };

    private AutomatCannon A2;

    private java.util.Timer timer = new java.util.Timer();

    private class CannonTimerTask extends java.util.TimerTask {
        public void run() {
            //  .!
            A2.A(3);
        };
    };
    private CannonTimerTask timerTask = new CannonTimerTask();

    /**
     * Cannon's owner
     */
    private Unit owner;

    /**
     * Returns the owner of the cannon
     */
    public Unit getOwner() {
        return owner;
    }

    /**
     * .      
     * @param owner  
     */
    public Cannon(Unit owner) {
        this.owner = owner;
        cannonName = owner.getName() + " cannon";
        A2 = new AutomatCannon();
    };

    /**
     *   " "
     */
    public void fire() {
        A2.A(1);
    }

    /**
     *   " "
     */
    public void nofire() {
        A2.A(2);
    }

}

;
