package ssc;

import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;

/**
 * ,     ,
 *      BattleField.
 *       
 *      .
 * @author Gavrilov M.
 */
public class Controller 
	implements MouseMotionListener, MouseListener, KeyListener
{
	/**
	 *  
	 */
	protected BattleField field;

	/**
	 *    
	 */
	ControlPanel control;

	/**
	 *  
	 */
	ClientArea clientArea;

	// TODO: debug only!!! delete in release!!!
	ControlPanel btnpanel;

	/**
	 *  
	 * @param field  
	 */
    public Controller(BattleField field, ControlPanel control, ClientArea clientArea) {
        this.field = field;
        this.control = control;
        this.clientArea = clientArea;
        clientArea.addMouseMotionListener(this);
        clientArea.addMouseListener(this);

        clientArea.addKeyListener(this);
        control.addKeyListener(this);

        btnpanel = control;
        control.setUnit(null);//(Unit)units.elementAt(6);
    }

	/**
	 *       
	 * @return  
	 */
	public BattleField getBattleField() {
		return field;
	}

	/**
	 *   
	 * @return  
	 */
	 public ControlPanel getControlPanel() {
	 	return control;
	 }

	/**
	 *   
	 * @return  
	 */
	 public ClientArea getClientArea() {
	 	return clientArea;
	 }

	/**
	 *        (x, y)
	 * @param x x 
	 * @param y y 
	 */
	public void mouseLPressed(int x, int y) {
		Point p = new Point(x, y);
		field.screenToAbsolute(p);
		int mouseX = p.x; 
		int mouseY = p.y;
        for (Iterator iterator = field.units.iterator(); iterator.hasNext();) {
            GameObject AnotherUnit = (GameObject)iterator.next();
            if (AnotherUnit != null) 
            if ((AnotherUnit.ifin(mouseX, mouseY))&&(AnotherUnit != btnpanel.getUnit())) {
                btnpanel.pressRMouse(AnotherUnit);
                return;
            }
        }           
        if (btnpanel.getUnit() != null) btnpanel.getUnit().deselect();
        btnpanel.pressRMouse(mouseX, mouseY);
        if (btnpanel.getUnit() != null) btnpanel.getUnit().select();
	}
            
	/**
	 *        (x, y)
	 * @param x x 
	 * @param y y 
	 */
	public void mouseRPressed(int x, int y) {
		Point p = new Point(x, y);
		field.screenToAbsolute(p);
		int mouseX = p.x; 
		int mouseY = p.y;
        boolean flag = true; //   ,  ,     
        for (Iterator iterator = field.units.iterator(); iterator.hasNext();) {
            GameObject AnotherUnit = (GameObject)iterator.next();
            if (AnotherUnit != null) 
            if (AnotherUnit.ifin(mouseX, mouseY)) {
                if (btnpanel.getUnit() != null) {
                    btnpanel.getUnit().deselect();
                }
                btnpanel.pressLMouse(AnotherUnit);
                if (btnpanel.getUnit() != null) {
                    btnpanel.getUnit().select();
                }
                flag = false;
            };
        };
        if (flag) {
            if (btnpanel.getUnit() != null) btnpanel.getUnit().deselect();
            btnpanel.pressLMouse(mouseX, mouseY);
            if (btnpanel.getUnit() != null) btnpanel.getUnit().select();
        };
	}

	/**
	 *   
	 */
	public void processTimer() {
		field.checkDeaded();
		field.processTimer();
                clientArea.repaint();
                btnpanel.unitUpdate(); 
		control.update();
	}

	/**
	 *    
	 * @param g  
	 */
	public void processPaint(Graphics g) {
     	// TODO: delete preferredcursor from control panel to smth. else
     	clientArea.setCursor(control.getPreferredClientAreaCursor());
		field.paint(g, clientArea.getWidth(), clientArea.getHeight());
	}


	/* MouseMotionListener */
    public void mouseDragged(MouseEvent e) {
    };

    public void mouseMoved(MouseEvent e) {
    };

    /* MouseListener */
    public void mouseClicked(MouseEvent e) {};
   
    public void mouseEntered(MouseEvent e) {}
    
    public void mouseExited(MouseEvent e) {}

    public void mousePressed(MouseEvent e) {
    	if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) == 0)
    		mouseLPressed(e.getX(), e.getY());
    	else
    		mouseRPressed(e.getX(), e.getY());
    }

    public void mouseReleased(MouseEvent e) {}


	/* KeyListener */
    public void keyTyped(KeyEvent e) {
    }
     
    public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ESCAPE) {
            btnpanel.pressESC();
        } else if (e.getKeyCode() == KeyEvent.VK_DOWN) {
    		field.viewCenter.y -= 20;    	
        } else if (e.getKeyCode() == KeyEvent.VK_UP) {
    		field.viewCenter.y += 20;    	
        } else if (e.getKeyCode() == KeyEvent.VK_LEFT) {
    		field.viewCenter.x += 20;    	
        } else if (e.getKeyCode() == KeyEvent.VK_RIGHT) {
    		field.viewCenter.x -= 20;    	
        }
    } 
    public void keyReleased(KeyEvent e) {} 
}