package ssc;

import java.awt.*;
import javax.swing.*;
import java.util.*;

import jarresources.*;

abstract public class ImageMap {
    protected static Map imageMap = new HashMap(); // hash of images
    protected static Map cursorMap = new HashMap(); // hash of cursors

    protected static class CursorInfo {
        public String path;
        public Point center;
        public String name;

        public CursorInfo(String tpath, Point tcenter, String tname) {
            path = tpath;
            center = tcenter;
            name = tname;
        }
    };

    /**
     * Return {@link ImageIcon} with specified path
     */
    public static ImageIcon getImageIcon(String path) {
        if (imageMap.containsKey(path))
            return (ImageIcon) imageMap.get(path);
        JarResources jar = new JarResources("ssc.jar");

        ImageIcon img = new ImageIcon(Toolkit.getDefaultToolkit().createImage(jar.getResource(path)));
        imageMap.put(path, img);
        return img;
    }

    private static JarResources jar;

    /**
     * Return {@link Image} with specified path
     */
    public static Image getImage(String path) {
        if (jar == null) {
            jar = new JarResources("ssc.jar");
        }
        return Toolkit.getDefaultToolkit().createImage(jar.getResource(path));
    }


    /**
     * Returns {@link Cursor} with specified name ant path
     */
    public static Cursor getCursor(String path, Point center, String name) {
        CursorInfo ci = new CursorInfo(path, center, name);
        if (cursorMap.containsKey(ci))
            return (Cursor) cursorMap.get(ci);
        Cursor cursor = Toolkit.getDefaultToolkit().createCustomCursor(
                getImage(path),
                center,
                name);
        cursorMap.put(ci, cursor);
        return cursor;
    }

}